/*
 * _version.h
 *
 *  Created on: 2. apr. 2021
 *      Author: teig
 */


#ifndef VERSION_H_
    #define VERSION_H_

    #define XTIMECOMPOSER_VERSION_STR "14.4.1"

    #define BEEP_BRRR_VERSION_STR "0.2.55" // x.y.zz
    #define BEEP_BRRR_               0255

    // 21dec2021 0255 BEEP-002 Studying the CS43L21 data sheet more, for trying to get to 8 kHz also for ADC
    //                         GIVING UP ON KNOCK-COME. The problem with not getting the ADC to run at 8 kHz
    //                         is a secondary problem. See blog note 219
    // 20Dec2021 0254          KC_SAMPLES_BUF_LEN 128 works, but not 256. This runs.
    // 18Dec2021 0253 BEEP-001 Searching for problem with no headset ADC out when 8 kHz
    //                         This is ok, 48 kHz. But 8 kHz is not yet
    // 17Dec2021 0252 OVERSAMPLING_FACTOR is new
    // 15Dec2021 0251 NUM_TIMEOUTS_BEFORE_SCREEN_DARK now works!
    // 14Dec2021 0250 SCREEN_ABOUT instead of SCREEN_INIT at power-up
    // 14dec2021 0249 Exercising p_scope_violet like 0244 is much better
    // 14Dec2021 0248 p_scope_gray now high while mic_array_get_next_time_domain_frame, it shows much more than just toggling on every sample
    // 13Dec2021 0247 All details now done, see new scope pictures. Probably to blog note
    // 13Dec2021 0246 Back to "standard" pulsing of p_scope_gray
    // 13Dec2021 0245 Extra time (us) used for the first adc out pairs, before the first "no adc out" then back to
    //                adc out I did find a solution to. Search for "0245": a "half-pair" to the ADC before the loop
    //                in mics_in_headset_out_task_a
    // 13Dec2021 0244 See scope photos 2021 12 13 13.30 Beep_BRRR v0244 I cannot understand INIT, which takes so long before Knock! seen
    // 13Dec2021 0243 See display photos
    // 12Dec2021 0243 I may have forgottten to commit? (I don't think so, I had removed an [[ordered]] in ..task:b
    // 12Dec2021 0243 Published in the blog
    // 12Dec2021 0242 I2C_EXTERNAL_SPEED_K_BITS_PER_SECOND 333 fine, but "Clean Project" first. KC_THROUGHPUT_TAG. See scope curves
    // 10Dec2021 0241 Two scope pins for ..task_a and one for ..task_b. See scope curves
    // 09Dec2021 0240 See ...Beep_BRRR v0240 display KnockCome measurements.jpg display photos: KC_THROUGHPUT_TAG
    // 08Dec2021 0239 DELAY_FIRST_PRINT_MS is new, solves (USE_XSCOPE == 1) problem
    // 08Dec2021 0238 More control of printing. xSCOPE only works if debug_print some time after start-up
    //                See https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#xscope
    // 07Dec2021 0237 xSCOPE up and running again. DEBUG_PRINT_GLOBAL_APP==1 and one DO_DEBUG_PRINT==1 must probably be set
    //                warning generated in _globals.h
    // 07dec2021 0236 Commit before testing xscope on another version
    //                UPDATE 07Dec2021: xScope does not at all work on this. Compared with 0220
    // 06Dec2021 0235 Testing the timing of the knock-come "come" phase on the slave side:
    //                  Test result 0235 with SAMPLING_FREQUENCY_HZ = 48000 and LIMIT_USED_TICKS 1483
    //                  Most often around 19-22 ticks (190-220 ns), but as much as 162 (1.6 us) seen.
    //                  mic_result.KnockCome_tics = KnockCome_tics_end - KnockCome_tics_start; // Will be sent next time!
    //                  TODO: write a smaller example and analyse the different timing. Probably something for xta?
    // 05Dec2021 0234 Testing values of used_tics in mics_in_headset_out.xc:
    //                  Test result 0233 with SAMPLING_FREQUENCY_HZ = 48000 and LIMIT_USED_TICKS 1483
    //                  The first round is much more, but after clear_debug_vars we have these values:
    //                     TEST_SINE_480HZ==1 ->  970 ticks =  9.7 us always below LIMIT_USED_TICKS
    //                                             88 ticks =  0.9 us if headset_gain_off
    //                     TEST_SINE_480HZ==0 -> 1120 ticks = 11.2 us always below LIMIT_USED_TICKS
    //                                             90 ticks =  0.9 us if headset_gain_off
    // 02dec2021 0233 TEST_SINE_480HZ makes sense with respect to headset volume
    // 02Dec2021 0232 used_tics in loop after mic_array_get_next_time_domain_frame is better understood
    // 30Nov2021 0231 KnockCome mark II
    // 28Nov2021 0230 KnockCome seems to work!?
    // 23Nov2021 0221 KnockCome_State introduced, as well as the files F_Pattern_KnockCome.h and .xc
    //                First on branch knock-come_task_a_with_task_b
    // 21Nov2021 0220 Compiling with [[ordered]] to test (just one component so far, meaningless)
    //                UPDATE 07Dec2021: xScope works on this after first button press. Compared with 0236
    // 19Nov2021 0219 Putting mic_array_get_next_time_domain_frame in a selct case timout instead af just the while(1). Works
    //                https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#implementation_d
    //         STUDY: "My Beep-BRRR notes" chapter "How many samples out of decimation per time?" at
    //                https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#how_many_samples_out_of_decimation_per_time
    // 10Nov2021 0218 Lots of #define names changed name to better understandability
    // 10Nov2021 0217 Buttons now increase etc. headset gain, display also
    // 09Nov2021 0216 headset_gain_context filled with button presses. dB not in display yet
    // 08Nov2021 0215 set_headset_gain and gain in dB steps
    // 05Nov2021 0214 Nothing special, working with understanding headset gain
    // 03Nov2021 0213 RUNS. Bidirectional union type data on ch_ab_bidir
    // 02Nov2021 0212 RUNS also with phase delay, ready for new menu system
    // 01Nov2021 0211 RUNS! Mics in and headset out. Menu system as old, but now I can start working on it
    // 30Oct2021 0210 COMPILES BUT NOT TESTED: AN00219 merged into here (=DAC headset out)
    //                File mics_in and headset_out merged -> mics_in_headset_out
    //                Only using CONFIG_USE_CHAN for ch_ab_bidir, so both it and CONFIG_USE_INTERFACE removed
    //                Constraints tile[0]: C:8/8 T:10/8 C:32/23 M:44692 S:8540 C:29772 D:9680
    //                Constraints tile[1]: C:8/1 T:10/1 C:32/1  M: 6248 S:1084 C: 4700 D: 464
    // 23Oct2021 0202 Same code as 0201 but
    //                AN00219_mics_in_headset_out       -> headset_out
    //                AN00220_app_phase_aligned_example -> mics_in
    // 23Oct2021 0201 Just a commit before major rethinking. Old files AN00220_app_phase_aligned_example
    //                and AN00219_mics_in_headset_out (was AN00219_headset_output) will get new names
    // 20Oct2021 0200 More config into mic_array_conf.h plus now starting to move code from AN00219
    //                New files AN00219_headset_output.h + .xc. NOT TESTED!
    // 25Sep2021 0110 Working with xscope, having some success, but isn't there at all
    // 16Sep2021      Just a build before going to Putten
    // 11Sep2021 0109 MIC_ARRAY_NUM_MICS to 4, but now it's the negative max value (=min value) of MIC_0 that changes,
    //                and the positive that is stable at 670763580 (0x27FB0A3C). Why?
    // 11Sep2021 0108 #error NESTED .h FILE in all files actually caught one!
    //                The most negative value of MIC_0 is constantly at 2147351294 (0x7FFDFAFE)
    // 10Sep2021 0107 int32_dB had an unecessary line
    // 09Sep2021 0106 Constraints tile[0]: C:8/8 T:10/8 C:32/21 M:48656 S:5192 C:28708 D:14756
    //                Constraints tile[1]: C:8/1 T:10/1 C:32/00 M:1540  S:0348 C:0864  D:00328
    // 09Sep2021 0106 Configs 01 and 02 removed. CONFIG_USE_INTERFACE new name and CONFIG_USE_CHAN new
    //                It seems like CONFIG_USE_CHAN does not break timing, I assume because it returns immediately,
    //                whereas interface does not return before the end of the case
    // 08Sep2021 0105 Display_screen once per second commented away
    // 08Sep2021 0104 Much works, but [[combinable]] Handle_Beep_BRRRR_task_b kills timing when it writes to the display
    //                (Update when on 0106: wrong assumption, it has to do with interface vs. channel)
    //                Constraints tile[0]: C:8/7 T:10/7 C:32/18 M:49244 S:5116 C:29364 D:14764
    //                Constraints tile[1]: C:8/1 T:10/1 C:32/00 M:1540  S:0348 C:0864  D:00328
    // 07Sep2021 0103 MIC_0 sample now sent to display. First version, seems to work?
    //                CONFIG_TEST_01_BUTTONS_AND_DISPLAY will not compile any more
    // 06Sep2021 0102 CONFIG_USE_INTERFACE combined. Works.
    // 06Sep2021 0101 Wrong (see below) As tested on 6Sep2021 0100 does not run, even if it compiles! But CONFIG_TEST_01_BUTTONS_AND_DISPLAY runs!
    // 25Apr2021 0100 Running AN00220code in here. Runs (use scope: 8kHz).
    // 13Apr2021 0013 MIC-ARRAY-1V3.xn now MIC-ARRAY-1V3-MOD.xn with added for xflash which now does not complain:
    //                PageSize SectorSize NumPages QE_REGISTER QE_BIT
    // 13Apr2021 0012 This compiles and runs, same as below. See DO_I2C_INIT and PAR_PLACE
    // 13Apr2021 0011 This compiles and runs, but doing the I2C before the while(1) does not!
    // 13Apr2021 0010 This compiles and runs, writes to display
    // 09Apr2021 0009 DO_LINE_2303_CRASH 1 now crashes (compiled with it), but DO_LINE_2303_CRASH 0 compiles
    //                13Apr2021 reported to XMOS, Ticket "Compiler crash in jenkins file types.cpp, line 2303 (#159996#)"
    // 09Apr2021 0008 Still crash in "line 2303"
    // 09Apr2021 0007 xcc1: internal compiler error
    //                Failed in /jenkins/RELEASE_14_4/sb/tools_xcc1_c_llvm/Common/Types/types.cpp, line 2303
    //                    isTypeInterfaceOrEnd(t)
    // 08Apr2021 0006 This works, even if there is no debounce in Buttons_demux_task. I can press as fast as
    //                I want. Should perhaps still make the protocol different, so that I don't have to use
    //                [[guarded]] void button_changed but not sure how BUTTON_ACTION_PRESSED_FOR_LONG would be
    //                influenced by it. Now this also works
    // 07Apr2021 0005 When I, after having made the zip for you, removed the dependency on lib_dsp (not used)
    //                and cleaned the project and rebuilt, NONE of the four configs will run correctly
    // 07Apr2021 0004 In main.xc: PAR_PLACE values 0 to 3 either runs fine, compiler crashes in "line 183",
    //                crashes at runtime and no progress at runtime. Sent to XMOS, ticket #159780#
    // 07Apr2021 0003 debugging buttons code, not wanting to use the XMOS lib_mic_array_board_support
    // 06Apr2021 0002 Handle_Beep_BRRRR_task_b etc skeleton up
    // 06Apr2021 0001 06Apr2021 First commit
#else
    #error NESTED .h FILE
#endif /* VERSION_H_ */
